<?php
/**
	Sign-in/Autologin for phpMyAdmin
*/

declare(strict_types=1);

/* Use cookies for session */
ini_set('session.use_cookies', 'true');

/* Change this to true if using phpMyAdmin over https */
$secure_cookie = false;

/* Need to have cookie visible from parent directory */
session_set_cookie_params(0, '/', '', $secure_cookie, true);

/* Create signon session */
$session_name = 'SignonSession';
session_name($session_name);

// Uncomment and change the following line to match your $cfg['SessionSavePath']
//session_save_path('/foobar');

@session_start();

$lang_locales = [
	'sq' => 'sq_AL',
	'ar' => 'ar_AE',
	'hy' => 'hy_AM',
	'az' => 'az_AZ',
	'bn' => 'bn_IN',
	'be' => 'be_BY',
	'bg' => 'bg_BG',
	'ca' => 'ca_ES',
	'zh_cn' => 'zh_CN',
	'zh_tw' => 'zh_TW',
	'cs' => 'cs_CZ',
	'da' => 'da_DK',
	'nl' => 'nl_NL',
	'en' => 'en_US',
	'en_gb' => 'en_GB',
	'et' => 'et_EE',
	'fi' => 'fi_FI',
	'fr' => 'fr_FR',
	'gl' => 'gl_ES',
	'de' => 'de_DE',
	'el' => 'el_GR',
	'he' => 'he_IL',
	'hu' => 'hu_HU',
	'id' => 'id_ID',
	'ia' => 'ia_FR',
	'it' => 'it_IT',
	'ja' => 'ja_JP',
	'kk' => 'kk_KZ',
	'ko' => 'ko_KR',
	'nb' => 'nb_NO',
	'pl' => 'pl_PL',
	'pt' => 'pt_PT',
	'pt_br' => 'pt_BR',
	'ro' => 'ro_RO',
	'ru' => 'ru_RU',
	'sr@latin' => 'sr_RS@latin',
	'si' => 'si_LK',
	'sk' => 'sk_SK',
	'sl' => 'sl_SI',
	'es' => 'es_ES',
	'sv' => 'sv_SE',
	'tr' => 'tr_TR',
	'uk' => 'uk_UA',
	'vi' => 'vi_VN'
];

$lang_options = [
	'sq' => 'value="sq">Shqip - Albanian',
	'ar' => 'value="ar">&#1575;&#1604;&#1593;&#1585;&#1576;&#1610;&#1577; - Arabic',
	'hy' => 'value="hy">Հայերէն - Armenian',
	'az' => 'value="az">Az&#601;rbaycanca - Azerbaijani',
	'bn' => 'value="bn">বাংলা - Bangla',
	'be' => 'value="be">&#1041;&#1077;&#1083;&#1072;&#1088;&#1091;&#1089;&#1082;&#1072;&#1103; - Belarusian',
	'bg' => 'value="bg">&#1041;&#1098;&#1083;&#1075;&#1072;&#1088;&#1089;&#1082;&#1080; - Bulgarian',
	'ca' => 'value="ca">Catal&agrave; - Catalan',
	'zh_cn' => 'value="zh_cn">&#20013;&#25991; - Chinese simplified',
	'zh_tw' => 'value="zh_tw">&#20013;&#25991; - Chinese traditional',
	'cs' => 'value="cs">Čeština - Czech',
	'da' => 'value="da">Dansk - Danish',
	'nl' => 'value="nl">Nederlands - Dutch',
	'en' => 'value="en">English',
	'en_gb' => 'value="en_gb">English (United Kingdom)',
	'et' => 'value="et">Eesti - Estonian',
	'fi' => 'value="fi">Suomi - Finnish',
	'fr' => 'value="fr">Fran&ccedil;ais - French',
	'gl' => 'value="gl">Galego - Galician',
	'de' => 'value="de">Deutsch - German',
	'el' => 'value="el">&Epsilon;&lambda;&lambda;&eta;&nu;&iota;&kappa;&#940; - Greek',
	'he' => 'value="he">&#1506;&#1489;&#1512;&#1497;&#1514; - Hebrew',
	'hu' => 'value="hu">Magyar - Hungarian',
	'id' => 'value="id">Bahasa Indonesia - Indonesian',
	'ia' => 'value="ia">Interlingua',
	'it' => 'value="it">Italiano - Italian',
	'ja' => 'value="ja">&#26085;&#26412;&#35486; - Japanese',
	'kk' => 'value="kk">Қазақ - Kazakh',
	'ko' => 'vaue="ko">&#54620;&#44397;&#50612; - Korean',
	'nb' => 'value="nb">Norsk - Norwegian',
	'pl' => 'value="pl">Polski - Polish',
	'pt' => 'value="pt">Portugu&ecirc;s - Portuguese',
	'pt_br' => 'value="pt_br">Portugu&ecirc;s (Brasil) - Portuguese (Brazil)',
	'ro' => 'value="ro">Rom&acirc;n&#259; - Romanian',
	'ru' => 'value="ru">&#1056;&#1091;&#1089;&#1089;&#1082;&#1080;&#1081; - Russian',
	'sr@latin' => 'value="sr@latin">Srpski - Serbian (latin)',
	'si' => 'value="si">&#3523;&#3538;&#3458;&#3524;&#3517; - Sinhala',
	'sk' => 'value="sk">Sloven&#269;ina - Slovak',
	'sl' => 'value="sl">Sloven&scaron;&#269;ina - Slovenian',
	'es' => 'value="es">Espa&ntilde;ol - Spanish',
	'sv' => 'value="sv">Svenska - Swedish',
	'tr' => 'value="tr">T&uuml;rk&ccedil;e - Turkish',
	'uk' => 'value="uk">&#1059;&#1082;&#1088;&#1072;&#1111;&#1085;&#1089;&#1100;&#1082;&#1072; - Ukrainian',
	'vi' => 'value="vi">Tiếng Việt - Vietnamese'
];

function language_selector($locale) {
	$is_selected = 'en';
	if (isset($locale)) {
		$is_selected = $locale;
	}
	global $lang_options;
	foreach ($lang_options as $key => $value) {
		if ($is_selected == $key) {
			echo '<option selected="selected" ' . $value . "</option>\n";
		} else {
			echo '<option ' . $value . "</option>\n";
		}
	}
};

/* Set the language if param given */
$language = 'en';
$text_direction = 'ltr';
if (isset($_REQUEST['lang'])) {
	if (array_key_exists($_REQUEST['lang'], $lang_locales)) {
		$language = filter_var($_REQUEST['lang'], FILTER_SANITIZE_STRING);
	}
	if (preg_match("/ar|he/", $language)) {
		$text_direction = 'rtl';
	}
}

/* Was data posted? */
if (isset($_POST['user'])) {
	/* Store there credentials */
	$_SESSION['PMA_single_signon_user'] = filter_var($_POST['user'], FILTER_SANITIZE_STRING);
	$_SESSION['PMA_single_signon_password'] = $_POST['password'];
	$_SESSION['PMA_single_signon_host'] = filter_var($_POST['host'], FILTER_SANITIZE_STRING);
	$_SESSION['PMA_single_signon_HMAC_secret'] = hash('sha1', uniqid(strval(rand()), true));
	$id = session_id();
	/* Close that session */
	@session_write_close();
	/* Redirect to phpMyAdmin (should use absolute URL here!) */
	header("Location: ../index.php?lang=$language");
} elseif ((isset($_REQUEST['pma_username']) and strlen($_REQUEST['pma_username']) > 0) and (isset($_REQUEST['pma_password']) and strlen($_REQUEST['pma_password']) > 0) and (isset($_REQUEST['pma_servername']) and strlen($_REQUEST['pma_servername']) > 0)) {
	/* if params were passed then use those values */
	$_SESSION['PMA_single_signon_user'] = filter_var($_REQUEST['pma_username'], FILTER_SANITIZE_STRING);
	$_SESSION['PMA_single_signon_password'] = $_REQUEST['pma_password'];
	$_SESSION['PMA_single_signon_host'] = filter_var($_REQUEST['pma_servername'], FILTER_SANITIZE_STRING);
	$_SESSION['PMA_single_signon_HMAC_secret'] = hash('sha1', uniqid(strval(rand()), true));
	$id = session_id();
	/* Close that session */
	@session_write_close();
	/* Redirect to phpMyAdmin (should use absolute URL here!) */
	header("Location: ../index.php?lang=$language");
} else {
	$hostname = '';
	$focus = 'serverNameInput';
	if (isset($_REQUEST['pma_servername']) and strlen($_REQUEST['pma_servername']) > 0) {
		$hostname = filter_var($_REQUEST['pma_servername'], FILTER_SANITIZE_STRING);
		$focus='input_username';
	}
	/* Show simple form */
	header('Content-Type: text/html; charset=utf-8');
	setlocale(LC_ALL, $lang_locales[$language] . '.UTF-8');
	bindtextdomain('phpmyadmin', 'locale');
	textdomain('phpmyadmin');

	echo '<!DOCTYPE HTML>';
	echo "<html dir=$text_direction>";

echo <<<'EOD'
<head>
<meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="referrer" content="no-referrer">
  <meta name="robots" content="noindex,nofollow">
  <style id="cfs-style">html{display: none;}</style>
  <link rel="icon" href="favicon.ico" type="image/x-icon">
  <link rel="shortcut icon" href="favicon.ico" type="image/x-icon">
  <link rel="stylesheet" type="text/css" href="./themes/pmahomme/jquery/jquery-ui.css">
  <link rel="stylesheet" type="text/css" href="js/vendor/codemirror/lib/codemirror.css?v=5.2.0">
  <link rel="stylesheet" type="text/css" href="js/vendor/codemirror/addon/hint/show-hint.css?v=5.2.0">
  <link rel="stylesheet" type="text/css" href="js/vendor/codemirror/addon/lint/lint.css?v=5.2.0">
  <link rel="stylesheet" type="text/css" href="./themes/pmahomme/css/theme.css?v=5.2.0">
  <title>phpMyAdmin</title>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/jquery/jquery.min.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/jquery/jquery-migrate.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/sprintf.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/ajax.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/keyhandler.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/jquery/jquery-ui.min.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/name-conflict-fixes.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/bootstrap/bootstrap.bundle.min.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/js.cookie.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/jquery/jquery.validate.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/jquery/jquery-ui-timepicker-addon.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/jquery/jquery.debounce-1.0.6.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/menu_resizer.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/cross_framing_protection.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/messages.php?l=en&v=5.2.0&lang=en"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/config.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/doclinks.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/functions.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/navigation.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/indexes.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/common.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/page_settings.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/codemirror/lib/codemirror.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/codemirror/mode/sql/sql.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/codemirror/addon/runmode/runmode.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/codemirror/addon/hint/show-hint.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/codemirror/addon/hint/sql-hint.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/codemirror/addon/lint/lint.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/codemirror/addon/lint/sql-lint.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/vendor/tracekit.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/error_report.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/drag_drop_import.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/shortcuts_handler.js?v=5.2.0"></script>
  <script data-cfasync="false" type="text/javascript" src="js/dist/console.js?v=5.2.0"></script>
<script data-cfasync="false" type="text/javascript">
// <![CDATA[
var maxInputVars = 1000;

CommonParams.setAll({common_query:"",server:"1",text_dir:"ltr",show_databases_navigation_as_tree:true,pma_text_default_tab:"Browse",pma_text_left_default_tab:"Structure",pma_text_left_default_tab2:false,LimitChars:"50",pftext:"",confirm:true,LoginCookieValidity:"1440",session_gc_maxlifetime:"1440",logged_in:false,is_https:false,rootPath:"/",arg_separator:"&",PMA_VERSION:"5.1.1",auth_type:"signon"});
var firstDayOfCalendar = '0';
var themeImagePath = '.\/themes\/pmahomme\/img\/';
var mysqlDocTemplate = '.\/url.php\u003Furl\u003Dhttps\u00253A\u00252F\u00252Fdev.mysql.com\u00252Fdoc\u00252Frefman\u00252F5.7\u00252Fen\u00252F\u002525s.html';
var maxInputVars = 10000;

function extendingValidatorMessages () {
  $.extend($.validator.messages, {
    required: 'This\u0020field\u0020is\u0020required',
    remote: 'Please\u0020fix\u0020this\u0020field',
    email: 'Please\u0020enter\u0020a\u0020valid\u0020email\u0020address',
    url: 'Please\u0020enter\u0020a\u0020valid\u0020URL',
    date: 'Please\u0020enter\u0020a\u0020valid\u0020date',
    dateISO: 'Please\u0020enter\u0020a\u0020valid\u0020date\u0020\u0028\u0020ISO\u0020\u0029',
    number: 'Please\u0020enter\u0020a\u0020valid\u0020number',
    creditcard: 'Please\u0020enter\u0020a\u0020valid\u0020credit\u0020card\u0020number',
    digits: 'Please\u0020enter\u0020only\u0020digits',
    equalTo: 'Please\u0020enter\u0020the\u0020same\u0020value\u0020again',
    maxlength: $.validator.format('Please\u0020enter\u0020no\u0020more\u0020than\u0020\u007B0\u007D\u0020characters'),
    minlength: $.validator.format('Please\u0020enter\u0020at\u0020least\u0020\u007B0\u007D\u0020characters'),
    rangelength: $.validator.format('Please\u0020enter\u0020a\u0020value\u0020between\u0020\u007B0\u007D\u0020and\u0020\u007B1\u007D\u0020characters\u0020long'),
    range: $.validator.format('Please\u0020enter\u0020a\u0020value\u0020between\u0020\u007B0\u007D\u0020and\u0020\u007B1\u007D'),
    max: $.validator.format('Please\u0020enter\u0020a\u0020value\u0020less\u0020than\u0020or\u0020equal\u0020to\u0020\u007B0\u007D'),
    min: $.validator.format('Please\u0020enter\u0020a\u0020value\u0020greater\u0020than\u0020or\u0020equal\u0020to\u0020\u007B0\u007D'),
    validationFunctionForDateTime: $.validator.format('Please\u0020enter\u0020a\u0020valid\u0020date\u0020or\u0020time'),
    validationFunctionForHex: $.validator.format('Please\u0020enter\u0020a\u0020valid\u0020HEX\u0020input'),
    validationFunctionForMd5: $.validator.format('This\u0020column\u0020can\u0020not\u0020contain\u0020a\u002032\u0020chars\u0020value'),
    validationFunctionForAesDesEncrypt: $.validator.format('These\u0020functions\u0020are\u0020meant\u0020to\u0020return\u0020a\u0020binary\u0020result\u003B\u0020to\u0020avoid\u0020inconsistent\u0020results\u0020you\u0020should\u0020store\u0020it\u0020in\u0020a\u0020BINARY,\u0020VARBINARY,\u0020or\u0020BLOB\u0020column.')
  });
}

ConsoleEnterExecutes=false

AJAX.scriptHandler
  .add('vendor/jquery/jquery.min.js', 0)
  .add('vendor/jquery/jquery-migrate.js', 0)
  .add('vendor/sprintf.js', 1)
  .add('ajax.js', 0)
  .add('keyhandler.js', 1)
  .add('vendor/jquery/jquery-ui.min.js', 0)
  .add('name-conflict-fixes.js', 1)
  .add('vendor/bootstrap/bootstrap.bundle.min.js', 1)
  .add('vendor/js.cookie.js', 1)
  .add('vendor/jquery/jquery.validate.js', 0)
  .add('vendor/jquery/jquery-ui-timepicker-addon.js', 0)
  .add('vendor/jquery/jquery.debounce-1.0.6.js', 0)
  .add('menu_resizer.js', 1)
  .add('cross_framing_protection.js', 0)
  .add('messages.php', 0)
  .add('config.js', 1)
  .add('doclinks.js', 1)
  .add('functions.js', 1)
  .add('navigation.js', 1)
  .add('indexes.js', 1)
  .add('common.js', 1)
  .add('page_settings.js', 1)
  .add('vendor/codemirror/lib/codemirror.js', 0)
  .add('vendor/codemirror/mode/sql/sql.js', 0)
  .add('vendor/codemirror/addon/runmode/runmode.js', 0)
  .add('vendor/codemirror/addon/hint/show-hint.js', 0)
  .add('vendor/codemirror/addon/hint/sql-hint.js', 0)
  .add('vendor/codemirror/addon/lint/lint.js', 0)
  .add('codemirror/addon/lint/sql-lint.js', 0)
  .add('vendor/tracekit.js', 1)
  .add('error_report.js', 1)
  .add('drag_drop_import.js', 1)
  .add('shortcuts_handler.js', 1)
  .add('console.js', 1)
;
$(function() {
  AJAX.fireOnload('vendor/sprintf.js');
  AJAX.fireOnload('keyhandler.js');
  AJAX.fireOnload('name-conflict-fixes.js');
  AJAX.fireOnload('vendor/bootstrap/bootstrap.bundle.min.js');
  AJAX.fireOnload('vendor/js.cookie.js');
  AJAX.fireOnload('menu_resizer.js');
  AJAX.fireOnload('config.js');
  AJAX.fireOnload('doclinks.js');
  AJAX.fireOnload('functions.js');
  AJAX.fireOnload('navigation.js');
  AJAX.fireOnload('indexes.js');
  AJAX.fireOnload('common.js');
  AJAX.fireOnload('page_settings.js');
  AJAX.fireOnload('vendor/tracekit.js');
  AJAX.fireOnload('error_report.js');
  AJAX.fireOnload('drag_drop_import.js');
  AJAX.fireOnload('shortcuts_handler.js');
  AJAX.fireOnload('console.js');
});
// ]]>
</script>

  <noscript><style>html{display:block}</style></noscript>
</head>
<body id=loginform>
EOD;
if (isset($_SESSION['PMA_single_signon_error_message'])) {
	echo '<p class="error">';
	echo $_SESSION['PMA_single_signon_error_message'];
	unset($_SESSION['PMA_single_signon_error_message']);
	echo '</p>';
}
echo <<<'EOD'
  <div id="page_content">
    <div class="container">
      <div class="row">
        <div class="col-12">
          <a href="./url.php?url=https%3A%2F%2Fwww.phpmyadmin.net%2F" target="_blank" rel="noopener noreferrer" class="logo">
            <img src="./themes/pmahomme/img/logo_right.png" id="imLogo" name="imLogo" alt="phpMyAdmin" border="0">
          </a>
          <h1>
EOD;
echo sprintf(gettext('Welcome to %s'), '<bdo dir="ltr" lang="en">phpMyAdmin</bdo>');
echo <<<'EOD'
         </h1>
         <noscript>
           <div class="alert alert-danger" role="alert">
             <img src="themes/dot.gif" title="" alt="" class="icon ic_s_error"> Javascript must be enabled past this point!
           </div>
         </noscript>
        <div class='hide js-show'>
        <div class="card mb-4">
        <div class="card-header">
EOD;
echo "<span id=\"languageSelectLabel\" dir=\"$text_direction\">";
$language_text = $language == 'en' ? gettext('Language') : gettext('Language') . ' - Language';
echo $language_text;
echo '</span></div><div class="card-body"><form method="get" action="signon.php" class="disableAjax"><fieldset>';
echo "<select name=\"lang\" class=\"form-select autosubmit\" dir=\"$text_direction\" id=\"languageSelect\" aria-labelledby=\"languageSelectLabel\">";
language_selector($language);
echo <<<'EOD'
               </select>
            </fieldset>
          </form>
         </div>
         </div>
         </div>
EOD;
echo <<<"EOF"
        <form method="post" id="login_form" action="signon.php?lang=$language" name="login_form" class="disableAjax hide js-show">
EOF;
echo <<<'EOD'
  <div class="card mb-4">
    <div class="card-header">
EOD;
echo gettext('Log in');
echo <<<'EOD'
    <a href="./doc/html/index.html" target="documentation"><img src="themes/dot.gif" title="Documentation" alt="Documentation" class="icon ic_b_help"></a>
    </div>
    <div class="card-body">
              <div class="row mb-3">
EOD;
$input_servername_title = gettext('You can enter hostname/IP address and port separated by space.');
echo "<label for=\"serverNameInput\" class=\"col-sm-4 col-form-label\" title=\"$input_servername_title\">";
echo gettext('Server:');
echo <<<'EOD'
        </label>
          <div class="col-sm-8">
EOD;
echo "<input type=\"text\" name=\"pma_servername\" id=\"serverNameInput\" value=\"$hostname\" size=\"24\" class=\"form-control\" title=\"$input_servername_title\">";
echo <<<"EOF"
                  <script>
                    window.setTimeout(function () {
                      document.getElementById("$focus").focus();
                    }, 10);
                  </script>
EOF;
echo <<<'EOD'

          </div>
        </div>

      <div class="row mb-3">
        <label for="input_username" class="col-sm-4 col-form-label">
EOD;
echo gettext('Username:');
echo <<<'EOD'
      </label>
        <div class="col-sm-8">
          <input type="text" name="pma_username" id="input_username" value="" class="form-control" autocomplete="username">
        </div>
      </div>

      <div class="row">
        <label for="input_password" class="col-sm-4 col-form-label">
EOD;
echo gettext('Password:');
echo <<<'EOD'

        </label>
        <div class="col-sm-8">
          <input type="password" name="pma_password" id="input_password" value="" class="form-control" autocomplete="current-password">
        </div>
      </div>

              <input type="hidden" name="server" value="1">
          </div>
    <div class="card-footer">
EOD;
$button = gettext('Log in');
echo "<input class=\"btn btn-primary\" value=\"$button\" type=\"submit\" id=\"input_go\">";
echo <<<'EOD'
          </div>
  </div>
</form>
      </div>
    </div>
  </body>
</html>
EOD;
}
